//+------------------------------------------------------------------+
//|                                                   TrainingEA.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern int MagicNumber = 0;
extern bool SignalMail = False;
extern bool EachTickMode = False;
extern double Lots = 0.1;
extern int Slippage = 3;
extern bool UseStopLoss = True;
extern int StopLoss = 7;
extern bool UseTakeProfit = True;
extern int TakeProfit = 100;
extern int BreakEven = 5;
extern int SecondSL = 15;

int BarCount;
int Current;
bool TickCheck = False;
int digit = 0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
int Order = SIGNAL_NONE;
   int pos, Ticket;
   double StopLossLevel, TakeProfitLevel;
   datetime Time0;
   
   digit  = MarketInfo(Symbol(),MODE_DIGITS);

   if (EachTickMode && Time[0] != Time0) { Time0=Time[0];
   TickCheck = False;
   }
   pos = OrdersTotal();
   Order = SIGNAL_NONE;

   //+------------------------------------------------------------------+
   //| Variable Begin                                                   |
   //+------------------------------------------------------------------+


double oldClose = iClose(NULL, PERIOD_M5, Current + 2);
double prevClose = iClose(NULL, PERIOD_M5, Current + 1);
double currOpen = iOpen(NULL, PERIOD_M5, 0);
double prevOpen = iOpen(NULL, PERIOD_M5, Current +1);
double oldOpen = iOpen(NULL, PERIOD_M5, Current +2);
double oldUBB = iBands(NULL, PERIOD_M5, 21, 2, 0, PRICE_CLOSE, MODE_UPPER, Current + 2);
double prevUBB = iBands(NULL, PERIOD_M5, 21, 2, 0, PRICE_CLOSE, MODE_UPPER, Current + 1);
double currUBB = iBands(NULL, PERIOD_M5, 21, 2, 0, PRICE_CLOSE, MODE_UPPER, 0);
double oldLBB = iBands(NULL, PERIOD_M5, 21, 2, 0, PRICE_CLOSE, MODE_LOWER, Current + 2);
double prevLBB = iBands(NULL, PERIOD_M5, 21, 2, 0, PRICE_CLOSE, MODE_LOWER, Current + 1);
double currLBB = iBands(NULL, PERIOD_M5, 21, 2, 0, PRICE_CLOSE, MODE_LOWER, 0);
double prevMA21 = iMA(NULL, PERIOD_M5, 21, 0, MODE_SMA, PRICE_CLOSE, Current + 1);
double oldMA21 = iMA(NULL, PERIOD_M5, 21, 0, MODE_SMA, PRICE_CLOSE, Current + 48);
double currMA21 = iMA(NULL, PERIOD_M5, 21, 0, MODE_SMA, PRICE_CLOSE, 0);
double currPSAR = iSAR(NULL, PERIOD_M5, 0.02, 0.2, 0);
double prevPSAR = iSAR(NULL, PERIOD_M5, 0.02, 0.2, Current + 1);
double ZeBid = Bid;
double ZeAsk = Ask;
double oldMACD = iMACD(NULL, PERIOD_M5, 12, 26, 9, PRICE_CLOSE, MODE_MAIN, Current + 2);
double prevMACD = iMACD(NULL, PERIOD_M5, 12, 26, 9, PRICE_CLOSE, MODE_MAIN, Current + 1);
double BBdis = prevUBB - prevLBB;
double BBdisval = 10;
double OpenPrice = OrderOpenPrice();
double OpenLBBdis = currOpen - currLBB;
double OpenLBBdisval = 6;
double OpenUBBdis = currUBB - currOpen;
double OpenUBBdisval = 6;

   
   //+------------------------------------------------------------------+
   //| Variable End                                                     |
   //+------------------------------------------------------------------+

   //Check position
   bool IsTrade = False;

   for(pos = OrdersTotal()-1; pos >= 0 ; pos--) if (
        OrderSelect(pos, SELECT_BY_POS)                 // Only my orders w/
    &&  OrderSymbol()       == Symbol() ){              // and my pair.
         IsTrade = True;
         if(OrderType() == OP_BUY) {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Buy)                                           |
            //+------------------------------------------------------------------+

                     if (prevClose > prevPSAR && ZeAsk < currPSAR) Order = SIGNAL_CLOSEBUY;

            //+------------------------------------------------------------------+
            //| Signal End(Exit Buy)                                             |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, Green);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Close Buy");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Breakeven
            if(BreakEven > 0) {                 
               if ( Bid-OrderOpenPrice()>Point*BreakEven ) 
               {
               double BuyStop = OrderOpenPrice();
               if(OrderStopLoss() < BuyStop)
               OrderModify(OrderTicket(),OrderOpenPrice(),
                           NormalizeDouble(BuyStop, digit),
                           OrderTakeProfit(),0,Green);
			      return(0);
			      }
                              }
            //the second Stoploss adjustment
            if(SecondSL > 0) {                 
               if ( Bid-OrderOpenPrice()>Point*SecondSL ) 
               {
               int SecondBSLvalue = 10;
               double SBLlvl = OrderOpenPrice()+Point*SecondBSLvalue;
               if (OrderStopLoss() > SBLlvl)
               OrderModify(OrderTicket(),OrderOpenPrice(),
                           NormalizeDouble(SBLlvl, digit),
                           OrderTakeProfit(),0,Green);
			      return(0);
			      }
                              }               
         } else {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Sell)                                          |
            //+------------------------------------------------------------------+

                     if (prevClose < prevPSAR && ZeBid > currPSAR) Order = SIGNAL_CLOSESELL;

            //+------------------------------------------------------------------+
            //| Signal End(Exit Sell)                                            |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, Red);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Breakeven
            if(BreakEven > 0 && OrderStopLoss() > OrderOpenPrice()) {                 
               if ( OrderOpenPrice()-Ask>Point*BreakEven ) 
               {
               double SellStop = OrderOpenPrice();
               if(OrderStopLoss() > SellStop)
               OrderModify(OrderTicket(),OrderOpenPrice(),
   		                  NormalizeDouble(SellStop, digit),
   		                  OrderTakeProfit(),0,Red);	    
               return(0);
               }    
                              }
            //the second Stoploss adjustment
            if(SecondSL > 0) {                 
               if ( OrderOpenPrice()-Ask>Point*SecondSL ) 
               {
               int SecondSSLvalue = 10;
               double SSLlvl = OrderOpenPrice()-Point*SecondSSLvalue;
               if (OrderStopLoss() > SSLlvl)
               OrderModify(OrderTicket(),OrderOpenPrice(),
                           NormalizeDouble(SSLlvl, digit),
                           OrderTakeProfit(),0,Red);
			      return(0);
			      }
                              }
         }
      }

   //+------------------------------------------------------------------+
   //| Signal Begin(Entry)                                              |
   //+------------------------------------------------------------------+

   if ((BBdis >= Point * BBdisval && prevMA21 > oldMA21 && prevOpen <= prevMA21 && currOpen > currMA21 && OpenUBBdis > Point * OpenUBBdisval) || (BBdis >= Point * BBdisval && (oldOpen > oldLBB && oldClose < oldLBB) && prevOpen < prevLBB && currOpen > prevLBB)) Order = SIGNAL_BUY;

   if ((BBdis >= Point * BBdisval && prevMA21 < oldMA21 && prevOpen >= prevMA21 && currOpen < currMA21 && OpenLBBdis > Point * OpenLBBdisval) || (BBdis >= Point * BBdisval && (oldOpen < oldUBB && oldClose > oldUBB) && prevOpen > prevUBB && currOpen < prevUBB)) Order = SIGNAL_SELL;


   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+

   //Buy
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (UseStopLoss) StopLossLevel = Ask - StopLoss * Point; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Ask + TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, StopLossLevel, TakeProfitLevel, "Buy(#" + MagicNumber + ")", MagicNumber, 0, Green);
         if(Ticket > 0) {   
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("BUY order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
			} else {
				Print("Error opening BUY order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   //Sell
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (UseStopLoss) StopLossLevel = Bid + StopLoss * Point; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Bid - TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, StopLossLevel, TakeProfitLevel, "Sell(#" + MagicNumber + ")", MagicNumber, 0, Red);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("SELL order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
			} else {
				Print("Error opening SELL order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   if (!EachTickMode) BarCount = Bars;   
//----
   return(0);
  }
//+------------------------------------------------------------------+